package Mastermind;

import swt.terminalinterface.*;
import swt.util.*;

import javax.swing.*;
import javax.swing.JOptionPane.*;

public class Engine {

  public SmartCard sc;
  public short tries;
  public byte whites;
  public byte blacks;

  SCThread scthread;

  public Engine() {
    scthread = new SCThread(this);
    scthread.start();
  }

  public void check(byte g1, byte g2, byte g3, byte g4) {
    try {
      byte[] retVal = sc.transmit(swt.util.HexString.hex_to_byte("00020000" +
          "04" +
          "0" + g1 +
          "0" + g2 +
          "0" + g3 +
          "0" + g4 + "04"));
      blacks = retVal[0];
      whites = retVal[1];
      tries = swt.util.ByteArray.getShort(retVal, 2);
    }
    catch (Exception ex) {
      while (true) {
        JOptionPane m = new JOptionPane();
        if (m.showConfirmDialog(null,
                                "Karte nicht gefunden! Nochmal versuchen?",
                                "MasterMind", JOptionPane.ERROR_MESSAGE,
                                JOptionPane.OK_CANCEL_OPTION) ==
            JOptionPane.YES_OPTION) {
          if (!scthread.isAlive()) scthread.start();
          check(g1, g2, g3, g4);
          break;
        }
        else {
          System.exit(1);
        }
      }
    }
  }
}
