/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */

import swt.terminalinterface.*;
import swt.util.*;


public class UA {


    public static final short ERR_OVERFLOW = 0x6600;
    public static final short ERR_UNDERFLOW = 0x6601;
    public static final short ERR_DIVISION = 0x6602;
    public static final short ERR_OP_NOT_SUPPORTED = 0x660A;


    public static void main(String[] args) {
        SmartCard sc;
        try {
            sc = SmartCard.getInstance();
            sc.connect();

            byte[] buffer = sc.transmit(swt.util.HexString.hex_to_byte( //select!
                    "00A404000673777400A200"));

            int test = 0;
            long tmp = 0;
            int exflag = 0;

            byte[] retVal;

            for (int k = 3; k < 4; k++) {
                System.out.println("Starting " + k + ":\n");
                for (int i = 0x0; i <= 0xFFFF; i += 1000) {
                    for (int j = 0x0; j <= 0xFFFF; j += 1000) {
                        retVal = sc.transmit(swt.util.HexString.hex_to_byte(
                                "00020000" +
                                "05" +
                                 swt.util.HexString.hexifyShort(i) +
                                swt.util.HexString.hexifyShort(j) +
                                swt.util.HexString.hexify(k) +
                                "02"));

                        if (retVal.length < 3) {
                            switch (swt.util.ByteArray.getShort(retVal, 0)) {
                            case ERR_OVERFLOW:
                                exflag = 1;
                                break;
                            case ERR_UNDERFLOW:
                                exflag = 2;
                                break;
                            case ERR_DIVISION:
                                exflag = 3;
                                break;
                            case ERR_OP_NOT_SUPPORTED:
                                exflag = 4;
                                break;
                            }
                        } else {
                            test = 0xFFFF &
                                   swt.util.ByteArray.getShort(retVal, 0);

                        }

                        switch (k) {
                        case 0:
                            tmp = (i < j) ? 1 : 0;
                            if (tmp != test) System.out.println("Fehler! " + i +
                                    j);
                            continue;
                        case 1:
                            tmp = i + j;
                            break;
                        case 2:
                            tmp = i - j;
                            break;
                        case 3:
                            tmp = (long) i * (long) j;
                            break;
                        case 4:
                            if (j != 0) tmp = i / j;
                            break;
                        case 5:
                            if (j != 0) tmp = i % j;
                            break;
                        }

                        if (tmp > 0xFFFF && exflag == 1) {
                            exflag = 0; continue;
                        } else if (tmp < 0 && exflag == 2) {
                            exflag = 0; continue;
                        } else if (j == 0 && exflag == 3) {
                            exflag = 0; continue;
                        } else if (exflag != 0) {
                            System.out.println("\nWrong exception bei " +
                                               i + ", " + j + ", " + k);
                            exflag = 0; continue;
                        }

                        if (tmp != test) {
                            System.out.println("\ntmp != test bei " + i +
                                               ", " + j + ", " + k);
                            System.out.println("tmp: " + tmp + ", test: " +
                                               test + "\n");
                        }
                    }
                }
            }

        } catch (swt.swtTerminalException ex) {
            System.out.println(ex.getStackTrace());
            //return false;
        }

        System.out.print("Finished!");
    }
}
