package Mastermind;

import java.util.*;

public class Engine {
    private byte [] master; // = {0,0,0,2};
    private byte tries;

    public Engine() {
        master = new byte[4];
        newGame();
    }

    public void newGame() {
        Random r = new Random();
        for (int i = 0; i < 4; i++) master[i] = (byte) r.nextInt(6);
        tries = 0;
    }

    public byte [] check(byte[] guess) {
        byte [] retVal = new byte[3];
        retVal[0] = 0;
        retVal[1] = 0;
        retVal[2] = ++tries;

        boolean[] status = {false,false,false,false};

        for (int i=0; i <= 3; i++){
            if (master[i] == guess[i]) {
                retVal[0]++;
                status[i] = true;
                guess[i] = 9;
            }
        }
        if (retVal[0] == 4) {
            newGame();
            return retVal;
        }

        for (int i=0; i <= 3; i++){
            if  (!status[i]) {
                for (int j=0; j <= 3; j++) {
                    if (i == j) continue;
                    if (master[i] == guess[j]) {
                        retVal[1]++;
                        guess[j] = 9;
                        break;
                    }
                }
            }
        }
        return retVal;
    }
}
